/**
 *--------------------------------------------------------------------\n
 *          HSLU T&A Hochschule Luzern Technik+Architektur            \n
 *--------------------------------------------------------------------\n
 *
 * \brief         Color sensor TCS3414 driver
 * \file
 * \author        Christian Jost, christian.jost@hslu.ch
 * \date          26.11.2012
 *
 * \b Language:   Ansi-C \n\n
 * \b Target:     MC-Car  \n
 *
 * \par Description:
 *
 * $Id: colSens.h 453 2012-12-18 09:44:13Z zajost $
 *--------------------------------------------------------------------
 */
#ifndef COLSENS_H
#define COLSENS_H

#include "platform.h"

#ifndef typeTColorRGB
#define typeTColorRGB
typedef struct
{
  uint8 green;
  uint8 red;
  uint8 blue;  
} tColorRGB;
#endif


#ifndef typeTColorHSV
#define typeTColorHSV
typedef struct
{
  uint16 hue;
  uint16 saturation;
  uint16 value;
} tColorHSV;
#endif


void colSensRGBtoHSV(tColorRGB *rgb, tColorHSV *hsv);
tError colSensReadColorRGB(tColorRGB *pColor);
tError colSensReadColorHSV(tColorHSV *color);

tError colSensParseCommand(char *cmd);

tError colSensSetWhite(void);
tError colSensSetBlack(void);

tError colSensInit(void);

#endif /* COLSENS_H */
